/**
 * Created by Administrator on 2016/1/19.
 */
var express = require('express');
var router = express.Router();
var baseRoute = require('./base.js');
var stateService = require('../service/state.js');

router.get('/', function (req, res, next) {
    res.render('result', {title: '统计结果'});
});

/**
 * 统计所有url pv
 */
router.get('/pv', function(req, res, next){
    var Model = stateService.model;
    var urlpathMap = {};
    var total = 0;
    Model.find({
        url: /.+/
    }).select({url:1}).exec(function(err, list){
        for(var i= 0, len=list.length; i<len; i++){
            var turl = list[i].url;
            var s = turl.match(/^(.+)\?*/);
            if(s){
                var t = s[1];
                if(!urlpathMap[t]){
                    urlpathMap[t] = 1;
                }
            }
        }
        for(var i in urlpathMap){
            total++;
        }
        _deal();
    });

    function _deal(){
        for(var i in urlpathMap){
            _count(i);
        }
    }

    function _count(i){
        var reg = new RegExp('^' + i);
        Model.count({
            url: reg
        }, function(err, count){
            urlpathMap[i] = count;
            total--;
            if(total === 0){
                _render();
            }
        });
    }

    function _render(){
        var arr = [];
        for(var i in urlpathMap){
            arr.push({
                urlpath: i,
                count: urlpathMap[i]
            });
        }
        baseRoute.success.call(res, arr);
    }
});

router.get('/pv/cond', function (req, res, next) {
    var q = req.query.q;
    var Model = stateService.model;
    Model.count({
        url: new RegExp(q)
    }, function(err, count){
        var arr = [];
        arr.push({
            urlpath: q,
            count: count
        });
        baseRoute.success.call(res, arr);
    });
});

module.exports = router;